package com.dahe.gldriver.utils

import android.content.Context
import com.amap.api.maps.model.LatLng
import com.amap.api.maps.model.Poi
import com.amap.api.navi.AmapNaviPage
import com.amap.api.navi.AmapNaviParams
import com.amap.api.navi.AmapNaviType
import com.dahe.gldriver.callback.MyINaviInfoCallback
import com.dahe.mylibrary.base.SingletonNoPHolder

/**
 * @ClassName NaviUtils
 * @Author john
 * @Date 2024/3/22 09:10
 * @Description TODO
 */
class NaviUtils private constructor(){
    companion object : SingletonNoPHolder<NaviUtils>(::NaviUtils)

    fun goNextPoint(context: Context,latLng: LatLng,startName:String = ""){
        AmapNaviPage.getInstance().showRouteActivity(
            context,
            AmapNaviParams(null, null, Poi(startName, latLng, ""), AmapNaviType.DRIVER),
            object : MyINaviInfoCallback() {}
        )
    }

    fun getRoute(context: Context,startLatLng: LatLng,endLatLng: LatLng,startName:String = "",endName:String = ""){
        val params = AmapNaviParams(
            Poi(startName, startLatLng, ""),
            null,
            Poi(endName, endLatLng, ""),
            AmapNaviType.DRIVER
        )
        params.setUseInnerVoice(true)
        AmapNaviPage.getInstance()
            .showRouteActivity(context, params, object : MyINaviInfoCallback() {})
    }
}